t/io_uring: make bs and polled IO configurable at runtime
[fio.git] / t / zbd / test-zbd-support
1 #!/bin/bash
2 #
3 # Copyright (C) 2018 Western Digital Corporation or its affiliates.
4 #
5 # This file is released under the GPL.
6
7 usage() {
8     echo "Usage: $(basename "$0") [-d] [-e] [-l] [-r] [-v] [-t <test>] [-z] <SMR drive device node>"
9 }
10
11 max() {
12     if [ "$1" -gt "$2" ]; then
13         echo "$1"
14     else
15         echo "$2"
16     fi
17 }
18
19 min() {
20     if [ "$1" -lt "$2" ]; then
21         echo "$1"
22     else
23         echo "$2"
24     fi
25 }
26
27 ioengine() {
28         if [ -n "$use_libzbc" ]; then
29                 echo -n "--ioengine=libzbc"
30         else
31                 echo -n "--ioengine=$1"
32         fi
33 }
34
35 set_io_scheduler() {
36     local dev=$1 sched=$2
37
38     [ -e "/sys/block/$dev" ] || return $?
39     if [ -e "/sys/block/$dev/mq" ]; then
40         case "$sched" in
41             noop)        sched=none;;
42             deadline)    sched=mq-deadline;;
43         esac
44     else
45         case "$sched" in
46             none)        sched=noop;;
47             mq-deadline) sched=deadline;;
48         esac
49     fi
50
51     echo "$sched" >"/sys/block/$dev/queue/scheduler"
52 }
53
54 check_read() {
55     local read
56
57     read=$(fio_read <"${logfile}.${test_number}")
58     echo "read: $read <> $1" >> "${logfile}.${test_number}"
59     [ "$read" = "$1" ]
60 }
61
62 check_written() {
63     local written
64
65     written=$(fio_written <"${logfile}.${test_number}")
66     echo "written: $written <> $1" >> "${logfile}.${test_number}"
67     [ "$written" = "$1" ]
68 }
69
70 # Compare the reset count from the log file with reset count $2 using operator
71 # $1 (=, -ge, -gt, -le, -lt).
72 check_reset_count() {
73     local reset_count
74
75     reset_count=$(fio_reset_count <"${logfile}.${test_number}")
76     echo "reset_count: test $reset_count $1 $2" >> "${logfile}.${test_number}"
77     eval "[ '$reset_count' '$1' '$2' ]"
78 }
79
80 # Whether or not $1 (/dev/...) is a SCSI device.
81 is_scsi_device() {
82     local d f
83
84     d=$(basename "$dev")
85     for f in /sys/class/scsi_device/*/device/block/"$d"; do
86         [ -e "$f" ] && return 0
87     done
88     return 1
89 }
90
91 run_fio() {
92     local fio opts
93
94     fio=$(dirname "$0")/../../fio
95
96     opts=("--max-jobs=16" "--aux-path=/tmp" "--allow_file_create=0" \
97           "--significant_figures=10" "$@")
98     opts+=(${var_opts[@]})
99     { echo; echo "fio ${opts[*]}"; echo; } >>"${logfile}.${test_number}"
100
101     "${dynamic_analyzer[@]}" "$fio" "${opts[@]}"
102 }
103
104 run_one_fio_job() {
105     local r
106
107     r=$(((RANDOM << 16) | RANDOM))
108     run_fio --name="$dev" --filename="$dev" "$@" --randseed="$r"        \
109             --thread=1 --direct=1
110 }
111
112 # Run fio on the first four sequential zones of the disk.
113 run_fio_on_seq() {
114     local opts=()
115
116     opts+=("--offset=$((first_sequential_zone_sector * 512))")
117     opts+=("--size=$((4 * zone_size))" "--zonemode=zbd")
118     if [ -z "$is_zbd" ]; then
119         opts+=("--zonesize=${zone_size}")
120     fi
121     run_one_fio_job "${opts[@]}" "$@"
122 }
123
124 # Check whether buffered writes are refused.
125 test1() {
126     run_fio --name=job1 --filename="$dev" --rw=write --direct=0 --bs=4K \
127             "$(ioengine "psync")" --size="${zone_size}" --thread=1      \
128             --zonemode=zbd --zonesize="${zone_size}" 2>&1 |
129         tee -a "${logfile}.${test_number}" |
130         grep -q 'Using direct I/O is mandatory for writing to ZBD drives'
131     local fio_rc=${PIPESTATUS[0]} grep_rc=${PIPESTATUS[2]}
132     case "$fio_rc" in
133         0|1) ;;
134         *)   return "$fio_rc"
135     esac
136     if [ -n "$is_zbd" ]; then
137         [ "$grep_rc" = 0 ]
138     else
139         [ "$grep_rc" != 0 ]
140     fi
141 }
142
143 # Block size exceeds zone size.
144 test2() {
145     local bs off opts=() rc
146
147     off=$(((first_sequential_zone_sector + 2 * sectors_per_zone) * 512))
148     bs=$((2 * zone_size))
149     opts+=("$(ioengine "psync")")
150     opts+=("--name=job1" "--filename=$dev" "--rw=write" "--direct=1")
151     opts+=("--zonemode=zbd" "--offset=$off" "--bs=$bs" "--size=$bs")
152     if [ -z "$is_zbd" ]; then
153         opts+=("--zonesize=${zone_size}")
154     fi
155     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
156     ! grep -q 'WRITE:' "${logfile}.${test_number}"
157 }
158
159 # Run fio against an empty zone. This causes fio to report "No I/O performed".
160 test3() {
161     local off opts=() rc
162
163     off=$((first_sequential_zone_sector * 512 + 128 * zone_size))
164     size=$((zone_size))
165     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
166     opts+=("--name=$dev" "--filename=$dev" "--offset=$off" "--bs=4K")
167     opts+=("--size=$size" "--zonemode=zbd")
168     opts+=("$(ioengine "psync")" "--rw=read" "--direct=1" "--thread=1")
169     if [ -z "$is_zbd" ]; then
170         opts+=("--zonesize=${zone_size}")
171     fi
172     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
173     grep -q 'READ:' "${logfile}.${test_number}"
174     rc=$?
175     if [ -n "$is_zbd" ]; then
176         [ $rc != 0 ]
177     else
178         [ $rc = 0 ]
179     fi
180 }
181
182 # Run fio with --read_beyond_wp=1 against an empty zone.
183 test4() {
184     local off opts=()
185
186     off=$((first_sequential_zone_sector * 512 + 129 * zone_size))
187     size=$((zone_size))
188     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
189     opts+=("--name=$dev" "--filename=$dev" "--offset=$off" "--bs=$size")
190     opts+=("--size=$size" "--thread=1" "--read_beyond_wp=1")
191     opts+=("$(ioengine "psync")" "--rw=read" "--direct=1" "--disable_lat=1")
192     opts+=("--zonemode=zbd" "--zonesize=${zone_size}")
193     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
194     check_read $size || return $?
195 }
196
197 # Sequential write to sequential zones.
198 test5() {
199     local size
200
201     size=$((4 * zone_size))
202     run_fio_on_seq "$(ioengine "psync")" --iodepth=1 --rw=write \
203                    --bs="$(max $((zone_size / 64)) "$logical_block_size")"\
204                    --do_verify=1 --verify=md5                           \
205                    >>"${logfile}.${test_number}" 2>&1 || return $?
206     check_written $size || return $?
207     check_read $size || return $?
208 }
209
210 # Sequential read from sequential zones. Must be run after test5.
211 test6() {
212     local size
213
214     size=$((4 * zone_size))
215     run_fio_on_seq "$(ioengine "psync")" --iodepth=1 --rw=read  \
216                    --bs="$(max $((zone_size / 64)) "$logical_block_size")"\
217                    >>"${logfile}.${test_number}" 2>&1 || return $?
218     check_read $size || return $?
219 }
220
221 # Random write to sequential zones, libaio, queue depth 1.
222 test7() {
223     local size=$((zone_size))
224
225     run_fio_on_seq "$(ioengine "libaio")" --iodepth=1 --rw=randwrite    \
226                    --bs="$(min 16384 "${zone_size}")"                   \
227                    --do_verify=1 --verify=md5 --size="$size"            \
228                    >>"${logfile}.${test_number}" 2>&1 || return $?
229     check_written $size || return $?
230     check_read $size || return $?
231 }
232
233 # Random write to sequential zones, libaio, queue depth 64.
234 test8() {
235     local size
236
237     size=$((4 * zone_size))
238     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite   \
239                    --bs="$(min 16384 "${zone_size}")"                   \
240                    --do_verify=1 --verify=md5                           \
241                    >>"${logfile}.${test_number}" 2>&1 || return $?
242     check_written $size || return $?
243     check_read $size || return $?
244 }
245
246 # Random write to sequential zones, sg, queue depth 1.
247 test9() {
248     local size
249
250     if ! is_scsi_device "$dev"; then
251         echo "$dev is not a SCSI device" >>"${logfile}.${test_number}"
252         return 0
253     fi
254
255     size=$((4 * zone_size))
256     run_fio_on_seq --ioengine=sg                                        \
257                    --iodepth=1 --rw=randwrite --bs=16K                  \
258                    --do_verify=1 --verify=md5                           \
259                    >>"${logfile}.${test_number}" 2>&1 || return $?
260     check_written $size || return $?
261     check_read $size || return $?
262 }
263
264 # Random write to sequential zones, sg, queue depth 64.
265 test10() {
266     local size
267
268     if ! is_scsi_device "$dev"; then
269         echo "$dev is not a SCSI device" >>"${logfile}.${test_number}"
270         return 0
271     fi
272
273     size=$((4 * zone_size))
274     run_fio_on_seq --ioengine=sg                                        \
275                    --iodepth=64 --rw=randwrite --bs=16K                 \
276                    --do_verify=1 --verify=md5                           \
277                    >>"${logfile}.${test_number}" 2>&1 || return $?
278     check_written $size || return $?
279     check_read $size || return $?
280 }
281
282 # Random write to sequential zones, libaio, queue depth 64, random block size.
283 test11() {
284     local size
285
286     size=$((4 * zone_size))
287     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite   \
288                    --bsrange=4K-64K --do_verify=1 --verify=md5          \
289                    --debug=zbd >>"${logfile}.${test_number}" 2>&1 || return $?
290     check_written $size || return $?
291     check_read $size || return $?
292 }
293
294 # Random write to sequential zones, libaio, queue depth 64, max 1 open zone.
295 test12() {
296     local size
297
298     size=$((8 * zone_size))
299     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=16K \
300                    --max_open_zones=1 --size=$size --do_verify=1 --verify=md5 \
301                    --debug=zbd >>"${logfile}.${test_number}" 2>&1 || return $?
302     check_written $size || return $?
303     check_read $size || return $?
304 }
305
306 # Random write to sequential zones, libaio, queue depth 64, max 4 open zones.
307 test13() {
308     local size
309
310     size=$((8 * zone_size))
311     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=16K \
312                    --max_open_zones=4 --size=$size --do_verify=1 --verify=md5 \
313                    --debug=zbd                                                \
314                    >>"${logfile}.${test_number}" 2>&1 || return $?
315     check_written $size || return $?
316     check_read $size || return $?
317 }
318
319 # Random write to conventional zones.
320 test14() {
321     local size
322
323     size=$((16 * 2**20)) # 20 MB
324     if [ $size -gt $((first_sequential_zone_sector * 512)) ]; then
325         echo "$dev does not have enough sequential zones" \
326              >>"${logfile}.${test_number}"
327         return 0
328     fi
329     run_one_fio_job "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=16K \
330                     --zonemode=zbd --zonesize="${zone_size}" --do_verify=1 \
331                     --verify=md5 --size=$size                              \
332                     >>"${logfile}.${test_number}" 2>&1 || return $?
333     check_written $((size)) || return $?
334     check_read $((size)) || return $?
335 }
336
337 # Sequential read on a mix of empty and full zones.
338 test15() {
339     local i off size
340
341     for ((i=0;i<4;i++)); do
342         [ -n "$is_zbd" ] &&
343             reset_zone "$dev" $((first_sequential_zone_sector +
344                                  i*sectors_per_zone))
345     done
346     off=$(((first_sequential_zone_sector + 2 * sectors_per_zone) * 512))
347     size=$((2 * zone_size))
348     run_one_fio_job "$(ioengine "psync")" --rw=write --bs=$((zone_size / 16))\
349                     --zonemode=zbd --zonesize="${zone_size}" --offset=$off \
350                     --size=$size >>"${logfile}.${test_number}" 2>&1 ||
351         return $?
352     check_written $size || return $?
353     off=$((first_sequential_zone_sector * 512))
354     size=$((4 * zone_size))
355     run_one_fio_job "$(ioengine "psync")" --rw=read --bs=$((zone_size / 16)) \
356                     --zonemode=zbd --zonesize="${zone_size}" --offset=$off \
357                     --size=$((size)) >>"${logfile}.${test_number}" 2>&1 ||
358         return $?
359     if [ -n "$is_zbd" ]; then
360         check_read $((size / 2))
361     else
362         check_read $size
363     fi
364 }
365
366 # Random read on a mix of empty and full zones. Must be run after test15.
367 test16() {
368     local off size
369
370     off=$((first_sequential_zone_sector * 512))
371     size=$((4 * zone_size))
372     run_one_fio_job "$(ioengine "libaio")" --iodepth=64 --rw=randread --bs=16K \
373                     --zonemode=zbd --zonesize="${zone_size}" --offset=$off \
374                     --size=$size >>"${logfile}.${test_number}" 2>&1 || return $?
375     check_read $size || return $?
376 }
377
378 # Random reads and writes in the last zone.
379 test17() {
380     local io off read size written
381
382     off=$(((disk_size / zone_size - 1) * zone_size))
383     size=$((disk_size - off))
384     # Overwrite the last zone to avoid that reading from that zone fails.
385     if [ -n "$is_zbd" ]; then
386         reset_zone "$dev" $((off / 512)) || return $?
387     fi
388     run_one_fio_job "$(ioengine "psync")" --rw=write --offset="$off"    \
389                     --zonemode=zbd --zonesize="${zone_size}"            \
390                     --bs="$zone_size" --size="$zone_size"               \
391                     >>"${logfile}.${test_number}" 2>&1 || return $?
392     check_written "$zone_size" || return $?
393     run_one_fio_job "$(ioengine "libaio")" --iodepth=8 --rw=randrw --bs=4K \
394                     --zonemode=zbd --zonesize="${zone_size}"            \
395                     --offset=$off --loops=2 --norandommap=1\
396                     >>"${logfile}.${test_number}" 2>&1 || return $?
397     written=$(fio_written <"${logfile}.${test_number}")
398     read=$(fio_read <"${logfile}.${test_number}")
399     io=$((written + read))
400     echo "Total number of bytes read and written: $io <> $size" \
401          >>"${logfile}.${test_number}"
402     [ $io = $((size * 2)) ];
403 }
404
405 # Out-of-range zone reset threshold and frequency parameters.
406 test18() {
407     run_fio_on_seq --zone_reset_threshold=-1 |&
408         tee -a "${logfile}.${test_number}"   |
409             grep -q 'value out of range' || return $?
410 }
411
412 test19() {
413     run_fio_on_seq --zone_reset_threshold=2  |&
414         tee -a "${logfile}.${test_number}"   |
415         grep -q 'value out of range' || return $?
416 }
417
418 test20() {
419     run_fio_on_seq --zone_reset_threshold=.4:.6 |&
420         tee -a "${logfile}.${test_number}"   |
421         grep -q 'the list exceeding max length' || return $?
422 }
423
424 test21() {
425     run_fio_on_seq --zone_reset_frequency=-1 |&
426         tee -a "${logfile}.${test_number}"   |
427         grep -q 'value out of range' || return $?
428 }
429
430 test22() {
431     run_fio_on_seq --zone_reset_frequency=2  |&
432         tee -a "${logfile}.${test_number}"   |
433         grep -q 'value out of range' || return $?
434 }
435
436 test23() {
437     run_fio_on_seq --zone_reset_frequency=.4:.6  |&
438         tee -a "${logfile}.${test_number}"   |
439         grep -q 'the list exceeding max length' || return $?
440 }
441
442 test24() {
443     local bs loops=9 size=$((zone_size))
444
445     bs=$(min $((256*1024)) "$zone_size")
446     run_fio_on_seq "$(ioengine "psync")" --rw=write --bs="$bs"          \
447                    --size=$size --loops=$loops                          \
448                    --zone_reset_frequency=.01 --zone_reset_threshold=.90 \
449                    >> "${logfile}.${test_number}" 2>&1 || return $?
450     check_written $((size * loops)) || return $?
451     check_reset_count -eq 8 ||
452         check_reset_count -eq 9 ||
453         check_reset_count -eq 10 || return $?
454 }
455
456 # Multiple non-overlapping sequential write jobs for the same drive.
457 test25() {
458     local i opts=()
459
460     for ((i=0;i<16;i++)); do
461         [ -n "$is_zbd" ] &&
462             reset_zone "$dev" $((first_sequential_zone_sector + i*sectors_per_zone))
463     done
464     for ((i=0;i<16;i++)); do
465         opts+=("--name=job$i" "--filename=$dev" "--thread=1" "--direct=1")
466         opts+=("--offset=$((first_sequential_zone_sector*512 + zone_size*i))")
467         opts+=("--size=$zone_size" "$(ioengine "psync")" "--rw=write" "--bs=16K")
468         opts+=("--zonemode=zbd" "--zonesize=${zone_size}" "--group_reporting=1")
469         opts+=(${var_opts[@]})
470     done
471     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
472 }
473
474 write_to_first_seq_zone() {
475     local loops=4 r
476
477     r=$(((RANDOM << 16) | RANDOM))
478     run_fio --name="$dev" --filename="$dev" "$(ioengine "psync")" --rw="$1" \
479             --thread=1 --do_verify=1 --verify=md5 --direct=1 --bs=4K    \
480             --offset=$((first_sequential_zone_sector * 512))            \
481             "--size=$zone_size" --loops=$loops --randseed="$r"          \
482             --zonemode=zbd --zonesize="${zone_size}" --group_reporting=1        \
483             --gtod_reduce=1 >> "${logfile}.${test_number}" 2>&1 || return $?
484     check_written $((loops * zone_size)) || return $?
485 }
486
487 # Overwrite the first sequential zone four times sequentially.
488 test26() {
489     write_to_first_seq_zone write
490 }
491
492 # Overwrite the first sequential zone four times using random writes.
493 test27() {
494     write_to_first_seq_zone randwrite
495 }
496
497 # Multiple overlapping random write jobs for the same drive.
498 test28() {
499     local i jobs=16 off opts
500
501     off=$((first_sequential_zone_sector * 512 + 64 * zone_size))
502     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
503     opts=("--debug=zbd")
504     for ((i=0;i<jobs;i++)); do
505         opts+=("--name=job$i" "--filename=$dev" "--offset=$off" "--bs=16K")
506         opts+=("--size=$zone_size" "$(ioengine "psync")" "--rw=randwrite")
507         opts+=("--thread=1" "--direct=1" "--zonemode=zbd")
508         opts+=("--zonesize=${zone_size}" "--group_reporting=1")
509         opts+=(${var_opts[@]})
510     done
511     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
512     check_written $((jobs * zone_size)) || return $?
513     check_reset_count -eq $jobs ||
514         check_reset_count -eq $((jobs - 1)) ||
515         return $?
516 }
517
518 # Multiple overlapping random write jobs for the same drive and with a limited
519 # number of open zones.
520 test29() {
521     local i jobs=16 off opts=()
522
523     off=$((first_sequential_zone_sector * 512 + 64 * zone_size))
524     size=$((16*zone_size))
525     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
526     opts=("--debug=zbd")
527     for ((i=0;i<jobs;i++)); do
528         opts+=("--name=job$i" "--filename=$dev" "--offset=$off" "--bs=16K")
529         opts+=("--size=$size" "--io_size=$zone_size" "--thread=1")
530         opts+=("$(ioengine "psync")" "--rw=randwrite" "--direct=1")
531         opts+=("--max_open_zones=4" "--group_reporting=1")
532         opts+=("--zonemode=zbd" "--zonesize=${zone_size}")
533         opts+=(${var_opts[@]})
534     done
535     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
536     check_written $((jobs * zone_size)) || return $?
537 }
538
539 # Random reads and writes across the entire disk for 30s.
540 test30() {
541     local off
542
543     off=$((first_sequential_zone_sector * 512))
544     run_one_fio_job "$(ioengine "libaio")" --iodepth=8 --rw=randrw      \
545                     --bs="$(max $((zone_size / 128)) "$logical_block_size")"\
546                     --zonemode=zbd --zonesize="${zone_size}" --offset=$off\
547                     --loops=2 --time_based --runtime=30s --norandommap=1\
548                     >>"${logfile}.${test_number}" 2>&1
549 }
550
551 # Random reads across all sequential zones for 30s. This is not only a fio
552 # test but also allows to verify the performance of a drive.
553 test31() {
554     local bs inc nz off opts size
555
556     # Start with writing 128 KB to 128 sequential zones.
557     bs=128K
558     nz=128
559     # shellcheck disable=SC2017
560     inc=$(((disk_size - (first_sequential_zone_sector * 512)) / (nz * zone_size)
561            * zone_size))
562     opts=()
563     for ((off = first_sequential_zone_sector * 512; off < disk_size;
564           off += inc)); do
565         opts+=("--name=$dev" "--filename=$dev" "--offset=$off" "--io_size=$bs")
566         opts+=("--bs=$bs" "--size=$zone_size" "$(ioengine "libaio")")
567         opts+=("--rw=write" "--direct=1" "--thread=1" "--stats=0")
568         opts+=("--zonemode=zbd" "--zonesize=${zone_size}")
569         opts+=(${var_opts[@]})
570     done
571     "$(dirname "$0")/../../fio" "${opts[@]}" >> "${logfile}.${test_number}" 2>&1
572     # Next, run the test.
573     off=$((first_sequential_zone_sector * 512))
574     size=$((disk_size - off))
575     opts=("--name=$dev" "--filename=$dev" "--offset=$off" "--size=$size")
576     opts+=("--bs=$bs" "$(ioengine "psync")" "--rw=randread" "--direct=1")
577     opts+=("--thread=1" "--time_based" "--runtime=30" "--zonemode=zbd")
578     opts+=("--zonesize=${zone_size}")
579     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
580 }
581
582 # Random writes across all sequential zones. This is not only a fio test but
583 # also allows to verify the performance of a drive.
584 test32() {
585     local off opts=() size
586
587     off=$((first_sequential_zone_sector * 512))
588     size=$((disk_size - off))
589     opts+=("--name=$dev" "--filename=$dev" "--offset=$off" "--size=$size")
590     opts+=("--bs=128K" "$(ioengine "psync")" "--rw=randwrite" "--direct=1")
591     opts+=("--thread=1" "--time_based" "--runtime=30")
592     opts+=("--max_open_zones=$max_open_zones" "--zonemode=zbd")
593     opts+=("--zonesize=${zone_size}")
594     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
595 }
596
597 # Write to sequential zones with a block size that is not a divisor of the
598 # zone size.
599 test33() {
600     local bs io_size size
601
602     size=$((2 * zone_size))
603     io_size=$((5 * zone_size))
604     bs=$((3 * zone_size / 4))
605     run_fio_on_seq "$(ioengine "psync")" --iodepth=1 --rw=write \
606                    --size=$size --io_size=$io_size --bs=$bs     \
607                    >> "${logfile}.${test_number}" 2>&1 || return $?
608     check_written $(((io_size + bs - 1) / bs * bs)) || return $?
609 }
610
611 # Write to sequential zones with a block size that is not a divisor of the
612 # zone size and with data verification enabled.
613 test34() {
614     local size
615
616     size=$((2 * zone_size))
617     run_fio_on_seq "$(ioengine "psync")" --iodepth=1 --rw=write --size=$size \
618                    --do_verify=1 --verify=md5 --bs=$((3 * zone_size / 4)) \
619                    >> "${logfile}.${test_number}" 2>&1 && return 1
620     grep -q 'not a divisor of' "${logfile}.${test_number}"
621 }
622
623 # Test 1/4 for the I/O boundary rounding code: $size < $zone_size.
624 test35() {
625     local bs off io_size size
626
627     off=$(((first_sequential_zone_sector + 1) * 512))
628     size=$((zone_size - 2 * 512))
629     bs=$((zone_size / 4))
630     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
631                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
632                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
633                     >> "${logfile}.${test_number}" 2>&1 && return 1
634     grep -q 'io_size must be at least one zone' "${logfile}.${test_number}"
635 }
636
637 # Test 2/4 for the I/O boundary rounding code: $size < $zone_size.
638 test36() {
639     local bs off io_size size
640
641     off=$(((first_sequential_zone_sector) * 512))
642     size=$((zone_size - 512))
643     bs=$((zone_size / 4))
644     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
645                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
646                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
647                     >> "${logfile}.${test_number}" 2>&1 && return 1
648     grep -q 'io_size must be at least one zone' "${logfile}.${test_number}"
649 }
650
651 # Test 3/4 for the I/O boundary rounding code: $size > $zone_size.
652 test37() {
653     local bs off size
654
655     if [ "$first_sequential_zone_sector" = 0 ]; then
656         off=0
657     else
658         off=$(((first_sequential_zone_sector - 1) * 512))
659     fi
660     size=$((zone_size + 2 * 512))
661     bs=$((zone_size / 4))
662     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
663                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
664                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
665                     >> "${logfile}.${test_number}" 2>&1
666     check_written $((zone_size)) || return $?
667 }
668
669 # Test 4/4 for the I/O boundary rounding code: $offset > $disk_size - $zone_size
670 test38() {
671     local bs off size
672
673     size=$((logical_block_size))
674     off=$((disk_size - logical_block_size))
675     bs=$((logical_block_size))
676     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
677                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
678                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
679                     >> "${logfile}.${test_number}" 2>&1 && return 1
680     grep -q 'io_size must be at least one zone' "${logfile}.${test_number}"
681 }
682
683 # Read one block from a block device.
684 read_one_block() {
685     local bs
686
687     bs=$((logical_block_size))
688     run_one_fio_job --rw=read "$(ioengine "psync")" --bs=$bs --size=$bs "$@" 2>&1 |
689         tee -a "${logfile}.${test_number}"
690 }
691
692 # Check whether fio accepts --zonemode=none for zoned block devices.
693 test39() {
694     [ -n "$is_zbd" ] || return 0
695     read_one_block --zonemode=none >/dev/null || return $?
696     check_read $((logical_block_size)) || return $?
697 }
698
699 # Check whether fio accepts --zonemode=strided for zoned block devices.
700 test40() {
701     local bs
702
703     bs=$((logical_block_size))
704     [ -n "$is_zbd" ] || return 0
705     read_one_block --zonemode=strided |
706         grep -q 'fio: --zonesize must be specified when using --zonemode=strided' ||
707         return $?
708     read_one_block --zonemode=strided --zonesize=$bs >/dev/null || return $?
709     check_read $bs || return $?
710 }
711
712 # Check whether fio checks the zone size for zoned block devices.
713 test41() {
714     [ -n "$is_zbd" ] || return 0
715     read_one_block --zonemode=zbd --zonesize=$((2 * zone_size)) |
716         grep -q 'job parameter zonesize.*does not match disk zone size'
717 }
718
719 # Check whether fio handles --zonesize=0 correctly for regular block devices.
720 test42() {
721     [ -n "$is_zbd" ] && return 0
722     read_one_block --zonemode=zbd --zonesize=0 |
723         grep -q 'Specifying the zone size is mandatory for regular block devices with --zonemode=zbd'
724 }
725
726 # Check whether fio handles --zonesize=1 correctly for regular block devices.
727 test43() {
728     [ -n "$is_zbd" ] && return 0
729     read_one_block --zonemode=zbd --zonesize=1 |
730         grep -q 'zone size must be at least 512 bytes for --zonemode=zbd'
731 }
732
733 # Check whether fio handles --zonemode=none --zonesize=1 correctly.
734 test44() {
735     read_one_block --zonemode=none --zonesize=1 |
736         grep -q 'fio: --zonemode=none and --zonesize are not compatible'
737 }
738
739 test45() {
740     local bs i
741
742     [ -z "$is_zbd" ] && return 0
743     bs=$((logical_block_size))
744     run_one_fio_job "$(ioengine "psync")" --iodepth=1 --rw=randwrite --bs=$bs\
745                     --offset=$((first_sequential_zone_sector * 512)) \
746                     --size="$zone_size" --do_verify=1 --verify=md5 2>&1 |
747         tee -a "${logfile}.${test_number}" |
748         grep -q "fio: first I/O failed. If .* is a zoned block device, consider --zonemode=zbd"
749 }
750
751 # Random write to sequential zones, libaio, 8 jobs, queue depth 64 per job
752 test46() {
753     local size
754
755     size=$((4 * zone_size))
756     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=4K \
757                    --group_reporting=1 --numjobs=8 \
758                    >> "${logfile}.${test_number}" 2>&1 || return $?
759     check_written $((size * 8)) || return $?
760 }
761
762 # Check whether fio handles --zonemode=zbd --zoneskip=1 correctly.
763 test47() {
764     local bs
765
766     [ -z "$is_zbd" ] && return 0
767     bs=$((logical_block_size))
768     run_one_fio_job "$(ioengine "psync")" --rw=write --bs=$bs \
769                     --zonemode=zbd --zoneskip=1          \
770                     >> "${logfile}.${test_number}" 2>&1 && return 1
771     grep -q 'zoneskip 1 is not a multiple of the device zone size' "${logfile}.${test_number}"
772 }
773
774 # Multiple overlapping random write jobs for the same drive and with a
775 # limited number of open zones. This is similar to test29, but uses libaio
776 # to stress test zone locking.
777 test48() {
778     local i jobs=16 off opts=()
779
780     off=$((first_sequential_zone_sector * 512 + 64 * zone_size))
781     size=$((16*zone_size))
782     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
783     opts=("--aux-path=/tmp" "--allow_file_create=0" "--significant_figures=10")
784     opts+=("--debug=zbd")
785     opts+=("$(ioengine "libaio")" "--rw=randwrite" "--direct=1")
786     opts+=("--time_based" "--runtime=30")
787     opts+=("--zonemode=zbd" "--zonesize=${zone_size}")
788     opts+=("--max_open_zones=4")
789     for ((i=0;i<jobs;i++)); do
790         opts+=("--name=job$i" "--filename=$dev" "--offset=$off" "--bs=16K")
791         opts+=("--io_size=$zone_size" "--iodepth=256" "--thread=1")
792         opts+=("--group_reporting=1")
793     done
794
795     fio=$(dirname "$0")/../../fio
796
797     { echo; echo "fio ${opts[*]}"; echo; } >>"${logfile}.${test_number}"
798
799     timeout -v -s KILL 45s \
800             "${dynamic_analyzer[@]}" "$fio" "${opts[@]}" \
801             >> "${logfile}.${test_number}" 2>&1 || return $?
802 }
803
804 tests=()
805 dynamic_analyzer=()
806 reset_all_zones=
807 use_libzbc=
808 zbd_debug=
809
810 while [ "${1#-}" != "$1" ]; do
811   case "$1" in
812     -d) dynamic_analyzer=(valgrind "--read-var-info=yes" "--tool=drd"
813                           "--show-confl-seg=no");
814         shift;;
815     -e) dynamic_analyzer=(valgrind "--read-var-info=yes" "--tool=helgrind");
816         shift;;
817     -l) use_libzbc=1; shift;;
818     -r) reset_all_zones=1; shift;;
819     -t) tests+=("$2"); shift; shift;;
820     -v) dynamic_analyzer=(valgrind "--read-var-info=yes");
821         shift;;
822     -z) zbd_debug=1; shift;;
823     --) shift; break;;
824   esac
825 done
826
827 if [ $# != 1 ]; then
828     usage
829     exit 1
830 fi
831
832 # shellcheck source=functions
833 source "$(dirname "$0")/functions" || exit $?
834
835 var_opts=()
836 if [ -n "$zbd_debug" ]; then
837     var_opts+=("--debug=zbd")
838 fi
839 dev=$1
840 realdev=$(readlink -f "$dev")
841 basename=$(basename "$realdev")
842
843 if [[ -b "$realdev" ]]; then
844         major=$((0x$(stat -L -c '%t' "$realdev"))) || exit $?
845         minor=$((0x$(stat -L -c '%T' "$realdev"))) || exit $?
846         disk_size=$(($(<"/sys/dev/block/$major:$minor/size")*512))
847
848         # When the target is a partition device, get basename of its
849         # holder device to access sysfs path of the holder device
850         if [[ -r "/sys/dev/block/$major:$minor/partition" ]]; then
851                 realsysfs=$(readlink "/sys/dev/block/$major:$minor")
852                 basename=$(basename "${realsysfs%/*}")
853         fi
854         logical_block_size=$(<"/sys/block/$basename/queue/logical_block_size")
855         case "$(<"/sys/class/block/$basename/queue/zoned")" in
856         host-managed|host-aware)
857                 is_zbd=true
858                 if ! result=($(first_sequential_zone "$dev")); then
859                         echo "Failed to determine first sequential zone"
860                         exit 1
861                 fi
862                 first_sequential_zone_sector=${result[0]}
863                 sectors_per_zone=${result[1]}
864                 zone_size=$((sectors_per_zone * 512))
865                 if ! max_open_zones=$(max_open_zones "$dev"); then
866                         echo "Failed to determine maximum number of open zones"
867                         exit 1
868                 fi
869                 set_io_scheduler "$basename" deadline || exit $?
870                 if [ -n "$reset_all_zones" ]; then
871                         reset_zone "$dev" -1
872                 fi
873                 ;;
874         *)
875                 first_sequential_zone_sector=$(((disk_size / 2) &
876                                                 (logical_block_size - 1)))
877                 zone_size=$(max 65536 "$logical_block_size")
878                 sectors_per_zone=$((zone_size / 512))
879                 max_open_zones=128
880                 set_io_scheduler "$basename" none || exit $?
881                 ;;
882         esac
883 elif [[ -c "$realdev" ]]; then
884         # For an SG node, we must have libzbc option specified
885         if [[ ! -n "$use_libzbc" ]]; then
886                 echo "Character device files can only be used with -l (libzbc) option"
887                 exit 1
888         fi
889
890         if ! $(is_zbc "$dev"); then
891                 echo "Device is not a ZBC disk"
892                 exit 1
893         fi
894         is_zbd=true
895
896         if ! disk_size=($(( $(zbc_disk_sectors "$dev") * 512))); then
897                 echo "Failed to determine disk size"
898                 exit 1
899         fi
900         if ! logical_block_size=($(zbc_logical_block_size "$dev")); then
901                 echo "Failed to determine logical block size"
902                 exit 1
903         fi
904         if ! result=($(first_sequential_zone "$dev")); then
905                 echo "Failed to determine first sequential zone"
906                 exit 1
907         fi
908         first_sequential_zone_sector=${result[0]}
909         sectors_per_zone=${result[1]}
910         zone_size=$((sectors_per_zone * 512))
911         if ! max_open_zones=$(max_open_zones "$dev"); then
912                 echo "Failed to determine maximum number of open zones"
913                 exit 1
914         fi
915         if [ -n "$reset_all_zones" ]; then
916                 reset_zone "$dev" -1
917         fi
918 fi
919
920 echo -n "First sequential zone starts at sector $first_sequential_zone_sector;"
921 echo " zone size: $((zone_size >> 20)) MB"
922
923 if [ "${#tests[@]}" = 0 ]; then
924     readarray -t tests < <(declare -F | grep "test[0-9]*" | \
925                                    tr -c -d "[:digit:]\n" | sort -n)
926 fi
927
928 logfile=$0.log
929
930 passed=0
931 failed=0
932 if [ -t 1 ]; then
933     red="\e[1;31m"
934     green="\e[1;32m"
935     end="\e[m"
936 else
937     red=""
938     green=""
939     end=""
940 fi
941 rc=0
942
943 intr=0
944 trap 'intr=1' SIGINT
945
946 for test_number in "${tests[@]}"; do
947     rm -f "${logfile}.${test_number}"
948     echo -n "Running test $(printf "%02d" $test_number) ... "
949     if eval "test$test_number"; then
950         status="PASS"
951         cc_status="${green}${status}${end}"
952         ((passed++))
953     else
954         status="FAIL"
955         cc_status="${red}${status}${end}"
956         ((failed++))
957         rc=1
958     fi
959     echo -e "$cc_status"
960     echo "$status" >> "${logfile}.${test_number}"
961     [ $intr -ne 0 ] && exit 1
962 done
963
964 echo "$passed tests passed"
965 if [ $failed -gt 0 ]; then
966     echo " and $failed tests failed"
967 fi
968 exit $rc